let moduleName = "arcane-ink";

export class DataBook{
    fileImg;
    filePath;
    buttonImg;
    rounded;
    userColors = {};
}

let dataBook = new DataBook();

function createPicturesContent(){
    let picturesContent = HtmlUtil.createElement("div", {elementClass: ["pictures_controls"]});
    let pictures_controls_data = HtmlUtil.createElement("div", {elementClass: ["pictures_controls_data"]});

    let leftCheck = document.createElement("div");
    let inputLeftCheck = HtmlUtil.createElement("input", {id: "leftCheck", name: "leftCheck", type: "checkbox"});
    let labelLeftCheck = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.leftCheck")});
    let onCircle = document.createElement("div");
    let inputOnCircle = HtmlUtil.createElement("input", {id: "onCircle", name: "onCircle", type: "checkbox"});
    let labelOnCircle =  HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.onCircle")});
    let rightCheck = document.createElement("div");
    let inputRightCheck = HtmlUtil.createElement("input", {id: "rightCheck", name: "rightCheck", type: "checkbox"});
    let labelRightCheck = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.rightCheck")});

    let scalePic = HtmlUtil.createElement("div", {elementClass: ["scalePic"]});
    
    let labelScalePic = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.scale")});
    let scaleDivlabel = HtmlUtil.createElement("div", {data: "data"});
    scaleDivlabel.appendChild(labelScalePic);

    let scaleSelectPic = HtmlUtil.createElement("select", {id: "scale", name: "scale"});
    let _options = {"one": "X1", "two": "X2", "three": "X3"};

    for (let [key, val] of Object.entries(_options)){
        let option = HtmlUtil.createElement("option", {value: key,text: val});
        scaleSelectPic.appendChild(option);
    }

    let scaleDivSelect = HtmlUtil.createElement("div", {data: "data"});
    scaleDivSelect.appendChild(scaleSelectPic);
    HtmlUtil.appendElements(scalePic, [scaleDivlabel, scaleDivSelect]);

    let refImg = HtmlUtil.createElement("img", {id: "refImg", name: "refImg" ,src: (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"});

    let refImgDiv = HtmlUtil.createElement("div", {elementClass: ["refImg"]});
    let figure = HtmlUtil.createElement("figure");
    figure.appendChild(refImg);
    refImgDiv.appendChild(figure);

    let pictureAbsoluteSize = HtmlUtil.createElement("div", {elementClass: ["picturesAbsoluteSize"]});
    let labelHeight = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.height")});
    let height = HtmlUtil.createElement("input", {elementClass: ["heightPic"], name: "heightPic", type: "number", value: ""});
    let divHeight = HtmlUtil.createElement("div");
    let labelWidth = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.pictureAndDesignMenu.width")});
    let width = HtmlUtil.createElement("input", {elementClass: ["widthPic"], name: "widthPic", type: "number", value: ""});
    let divWidth = HtmlUtil.createElement("div");
    HtmlUtil.appendElements(divHeight, [labelHeight, height]);
    HtmlUtil.appendElements(divWidth, [labelWidth, width]);

    HtmlUtil.appendElements(pictureAbsoluteSize, [divWidth, divHeight]);

    let picturesInput = HtmlUtil.createElement("input", {elementClass: ["picturesInput"], id: "picturesInput", name: "picturesInput", type: "text" ,value: (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"});
    
    let picturesInputDiv = HtmlUtil.createElement("div", {elementClass: ["picturesInputContainer"]});
    picturesInputDiv.appendChild(picturesInput);

    let buttonPictures = HtmlUtil.createElement("button", {elementClass: ["buttonAddPictures", "button"], id: "addPictures" , text: game.i18n.localize("MI.pictureAndDesignMenu.InsertPicture")});
    let divAddPictures = HtmlUtil.createElement("div", {data: "data"});
    divAddPictures.appendChild(buttonPictures);

    let buttonNarrative = HtmlUtil.createElement("button", {elementClass: ["buttonNarrative", "button"], id: "narrative", text: game.i18n.localize("MI.pictureAndDesignMenu.narrative")});
    let divNarrative = HtmlUtil.createElement("div", {data: "data"});
    divNarrative.appendChild(buttonNarrative);

    let buttonAdvice = HtmlUtil.createElement("button", {elementClass: ["buttonAdvice", "button"], id: "advice"});
    let butImg = HtmlUtil.createElement("img", {id: "butImg", name: "butImg", src: (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png"});
    let butImgP = HtmlUtil.createElement("p");
    let textP = HtmlUtil.createElement("p", {text: game.i18n.localize("MI.pictureAndDesignMenu.advice")});
    butImgP.appendChild(butImg);
    HtmlUtil.appendElements(buttonAdvice, [butImgP, textP]);
    let divAdvice = HtmlUtil.createElement("div", {data: "data"});
    divAdvice.appendChild(buttonAdvice);

    let buttonNotable = HtmlUtil.createElement("button", {elementClass: ["buttonNotable", "button"], id: "notable", text: game.i18n.localize("MI.pictureAndDesignMenu.notable")});
    let divNotable = HtmlUtil.createElement("div", {data: "data"});
    divNotable.appendChild(buttonNotable);

    HtmlUtil.appendElements(leftCheck, [inputLeftCheck, labelLeftCheck]);
    HtmlUtil.appendElements(onCircle, [inputOnCircle, labelOnCircle]);
    HtmlUtil.appendElements(rightCheck, [inputRightCheck, labelRightCheck]);

    
    let divsControls = [leftCheck, onCircle, rightCheck, scalePic, refImgDiv, pictureAbsoluteSize, picturesInputDiv, divAddPictures, divNarrative, divAdvice, divNotable];
    HtmlUtil.appendElements(pictures_controls_data, divsControls);

    picturesContent.appendChild(pictures_controls_data);
    return picturesContent.outerHTML;
}

function createReferenseContentTabs(){
    let referenseContentTabs = HtmlUtil.createElement("div", {elementClass: ["referenseContentTabs"]});
    let bold = HtmlUtil.createElement("b");
    let tabs = {
        "tab1": game.i18n.localize("MI.referenseContent.ability"),
        "tab2": game.i18n.localize("MI.referenseContent.skill"),
        "tab3": game.i18n.localize("MI.referenseContent.condition"),
        "tab4": game.i18n.localize("MI.referenseContent.creatureType"),
        "tab5": game.i18n.localize("MI.referenseContent.typeDamage"),
        "tab6": game.i18n.localize("MI.referenseContent.tool"),
        "tab7": game.i18n.localize("MI.referenseContent.areaOfEffect"),
        "tab8": game.i18n.localize("MI.referenseContent.component"),
        "tab9": game.i18n.localize("MI.referenseContent.spellSchool"),
        "tab10": game.i18n.localize("MI.referenseContent.rules")
    };
    let navigation = HtmlUtil.createElement("nav", {elementClass: ["referenseTabs"], data_group: "referense-tabs"});
    let referenseTabsContainer = HtmlUtil.createElement("div", {elementClass: ["referenseTabsContainer"]});
    for (let [tab, text] of Object.entries(tabs)){
        let a = HtmlUtil.createElement("a", {elementClass: ["itemRef"], data_tab: tab, text: text});
        let div = HtmlUtil.createElement("div");
        div.appendChild(a);
        referenseTabsContainer.appendChild(div);
    }
    navigation.appendChild(referenseTabsContainer);
    bold.appendChild(navigation);
    let br1 = HtmlUtil.createElement("br")

    let contentRefInput = setContentRefInput();

    let br2 = HtmlUtil.createElement("br")

    //section
    let sectionContentRef = HtmlUtil.createElement("section", {elementClass: ["contentRef"]});

    //ability
    let divContentabilit = getAbilityTab()
    //skill
    let divContentskill = getSkillTab()
    //condition
    let divContentabiCondition = getConditionTab()
    //creature type
    let divContentabiCreatureType = getCreatureTypeTab()
    //damage type
    let divContentabiTypeDamage = getTypeDamageTab()
    //tool
    let divContentabitoolsList = getToolTab()
    //areaOfEffect
    let divContentAreaOfEffect = getAreaOfEffectTab()
    //component
    let divContentComponent = getComponentTab()
    //spell school
    let divContentspellSchool = getSpellSchoolTab()
    //rules
    let divContentabirules = getRulesTab()

    HtmlUtil.appendElements(sectionContentRef, [
        divContentabilit, 
        divContentskill, 
        divContentabiCondition, 
        divContentabiCreatureType, 
        divContentabiTypeDamage, 
        divContentabitoolsList,
        divContentAreaOfEffect,
        divContentComponent,
        divContentspellSchool,
        divContentabirules
    ]);
    HtmlUtil.appendElements(referenseContentTabs, [bold, br1, contentRefInput, br2, sectionContentRef]);
    return referenseContentTabs.outerHTML;
}

function setContentRefInput(){
    let contentRefInput = HtmlUtil.createElement("div", {elementClass: ["contentRefInput"]});
    let cheks = [
        [
            {element: "div", args: {elementClass: ["numberCheck"]}},
            {element: "input", args: {id: "numberCheck", name: "numberCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.ModifierFromText")}},
        ],
        [
            {element: "div", args: {elementClass: ["NullCheck"]}},
            {element: "input", args: {id: "NullCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.emptyValue")}},
        ],
        [
            {element: "div", args: {elementClass: ["skillPassiveCheck"]}},
            {element: "input", args: {id: "skillPassiveCheck", type: "checkbox"}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.skillList.passiveCheck")}},
        ],
        [
            {element: "div", args: {elementClass: ["damageFormula"]}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.damageFormula")}},
            {element: "input", args: {id: "damageFormula", type: "text"}},
        ],
        [
            {element: "div", args: {elementClass: ["numberForMod"]}},
            {element: "label", args: {text: game.i18n.localize("MI.referenseContent.Modifier")}},
            {element: "input", args: {id: "numberForMod", type: "number"}},
        ]
    ];
    for (let elements of cheks){
        const div = HtmlUtil.createElement(elements[0].element, elements[0].args);
        const div2 = HtmlUtil.createElement(elements[0].element, elements[0].args);
        const divs = [div, div2];
        for (let i = 1; i < elements.length; i++){
            divs[i-1].appendChild(HtmlUtil.createElement(elements[i].element, elements[i].args));
        }
        HtmlUtil.appendElements(contentRefInput, divs);
    }
    return contentRefInput
}

function getAbilityTab(){
    let divContentabilit = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab1", data_group: "referense-tabs"});
    let abilityOptions = {
        "strength": game.i18n.localize("MI.referenseContent.abilityList.strength"),
        "dexterity": game.i18n.localize("MI.referenseContent.abilityList.dexterity"),
        "constitution": game.i18n.localize("MI.referenseContent.abilityList.constitution"),
        "intelligence": game.i18n.localize("MI.referenseContent.abilityList.intelligence"),
        "wisdom": game.i18n.localize("MI.referenseContent.abilityList.wisdom"),
        "charisma": game.i18n.localize("MI.referenseContent.abilityList.charisma")
    };
    let abilityContainer = HtmlUtil.createElement("div", {elementClass: ["abilityContainer"]});
    let labelAbility = HtmlUtil.createElement("label", {text: game.i18n.localize("MI.referenseContent.abilityList.savingThrow")});
    let inputAbilityCheck = HtmlUtil.createElement("input", {id: "abilityCheck", name: "abilityCheck", type: "checkbox"});

    let labelSelectAbility = HtmlUtil.createElement("label", {for: "ability", text: game.i18n.localize("MI.referenseContent.ability")});
    let selectAbility = HtmlUtil.createElement("select", {id: "ability", name: "ability"});
    let sorted = HtmlUtil.sortDict(abilityOptions);
    for (let [key, value] of Object.entries(sorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectAbility.appendChild(option);
    }
    let buttonAbilityContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAbilityContainer"]});
    let buttonAbility = HtmlUtil.createElement("button", {elementClass: ["buttonAbility", "button"], id: "buttonAbility", text: game.i18n.localize("MI.referenseContent.abilityList.setAbility")});
    buttonAbilityContainer.appendChild(buttonAbility);
    let divPackedAbility = HtmlUtil.toDivPack([labelAbility, inputAbilityCheck, labelSelectAbility, selectAbility]);
    HtmlUtil.appendElements(abilityContainer, divPackedAbility);
    abilityContainer.appendChild(buttonAbilityContainer);
    divContentabilit.appendChild(abilityContainer);
    return divContentabilit;
}

function getSkillTab(){
    let divContentskill = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab2", data_group: "referense-tabs"});
    let skillContainer = HtmlUtil.createElement("div", {elementClass: ["skillContainer"]});
    let skillOptions = {
        "acrobatics": game.i18n.localize("MI.referenseContent.skillList.acrobatics"),
        "animalHandling": game.i18n.localize("MI.referenseContent.skillList.animalHandling"),
        "arcana": game.i18n.localize("MI.referenseContent.skillList.arcana"),
        "athletics": game.i18n.localize("MI.referenseContent.skillList.athletics"),
        "deception": game.i18n.localize("MI.referenseContent.skillList.deception"),
        "history": game.i18n.localize("MI.referenseContent.skillList.history"),
        "insight": game.i18n.localize("MI.referenseContent.skillList.insight"),
        "intimidation": game.i18n.localize("MI.referenseContent.skillList.intimidation"),
        "investigation": game.i18n.localize("MI.referenseContent.skillList.investigation"),
        "medicine": game.i18n.localize("MI.referenseContent.skillList.medicine"),
        "nature": game.i18n.localize("MI.referenseContent.skillList.nature"),
        "perception": game.i18n.localize("MI.referenseContent.skillList.perception"),
        "performance": game.i18n.localize("MI.referenseContent.skillList.performance"),
        "persuasion": game.i18n.localize("MI.referenseContent.skillList.persuasion"),
        "religion": game.i18n.localize("MI.referenseContent.skillList.religion"),
        "sleightOfHand": game.i18n.localize("MI.referenseContent.skillList.sleightOfHand"),
        "stealth": game.i18n.localize("MI.referenseContent.skillList.stealth"),
        "survival": game.i18n.localize("MI.referenseContent.skillList.survival"),
    };
    let labelSkill = HtmlUtil.createElement("label", {for: "skill", text: game.i18n.localize("MI.referenseContent.skill")});
    let selectSkill = HtmlUtil.createElement("select", {id: "skill", name: "skill"});
    let sortedSkill = HtmlUtil.sortDict(skillOptions);
    for(let key in sortedSkill){
        let option = HtmlUtil.createElement("option", {value: key, text: sortedSkill[key]});
        selectSkill.appendChild(option);
    }
    let divPackedSkill = HtmlUtil.toDivPack([labelSkill, selectSkill]);
    HtmlUtil.appendElements(skillContainer, divPackedSkill);
    let buttonSkillContainer = HtmlUtil.createElement("div", {elementClass: ["buttonSkillContainer"]});
    let buttonSkill = HtmlUtil.createElement("button", {elementClass: ["buttonSkill", "button"],id: "buttonSkill", text: game.i18n.localize("MI.referenseContent.skillList.setSkill")});
    buttonSkillContainer.appendChild(buttonSkill);
    skillContainer.appendChild(buttonSkillContainer);
    divContentskill.appendChild(skillContainer);
    return divContentskill;
}

function getConditionTab(){
    let divContentabiCondition = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab3", data_group: "referense-tabs"});
    let conditionOptions = {
        "blinded": game.i18n.localize("MI.referenseContent.conditionList.blinded"),
        "charmed": game.i18n.localize("MI.referenseContent.conditionList.charmed"),
        "deafened": game.i18n.localize("MI.referenseContent.conditionList.deafened"),
        "exhaustion": game.i18n.localize("MI.referenseContent.conditionList.exhaustion"),
        "frightened": game.i18n.localize("MI.referenseContent.conditionList.frightened"),
        "grappled": game.i18n.localize("MI.referenseContent.conditionList.grappled"),
        "incapacitated": game.i18n.localize("MI.referenseContent.conditionList.incapacitated"),
        "invisible": game.i18n.localize("MI.referenseContent.conditionList.invisible"),
        "paralyzed": game.i18n.localize("MI.referenseContent.conditionList.paralyzed"),
        "petrified": game.i18n.localize("MI.referenseContent.conditionList.petrified"),
        "poisoned": game.i18n.localize("MI.referenseContent.conditionList.poisoned"),
        "prone": game.i18n.localize("MI.referenseContent.conditionList.prone"),
        "restrained": game.i18n.localize("MI.referenseContent.conditionList.restrained"),
        "stunned": game.i18n.localize("MI.referenseContent.conditionList.stunned"),
        "unconscious": game.i18n.localize("MI.referenseContent.conditionList.unconscious")
    };
    let conditionContainer = HtmlUtil.createElement("div", {elementClass: ["conditionContainer"]});
    let labelCondition = HtmlUtil.createElement("label", {for: "condition", text: game.i18n.localize("MI.referenseContent.condition")});
    let selectCondition = HtmlUtil.createElement("select", {id: "condition", name: "condition"});
    let ConditionsSorted = HtmlUtil.sortDict(conditionOptions);
    for (let [key, value] of Object.entries(ConditionsSorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectCondition.appendChild(option);
    }
    let buttonConditionContainer =  HtmlUtil.createElement("div", {elementClass: ["buttonConditionContainer"]});
    let buttonCondition = HtmlUtil.createElement("button", {elementClass: ["buttonCondition", "button"], id: "buttonCondition", text: game.i18n.localize("MI.referenseContent.conditionList.setCondition")});
    let conditionDivPacked = HtmlUtil.toDivPack([labelCondition, selectCondition])
    buttonConditionContainer.appendChild(buttonCondition);
    conditionDivPacked.push(buttonConditionContainer);
    HtmlUtil.appendElements(conditionContainer, conditionDivPacked);
    divContentabiCondition.appendChild(conditionContainer);
    return divContentabiCondition;
}

function getCreatureTypeTab(){
    let divContentabiCreatureType = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab4", data_group: "referense-tabs"});
    let creatureTypeOptions = {
        "aberration": game.i18n.localize("MI.referenseContent.creatureTypeList.aberration"),
        "beast": game.i18n.localize("MI.referenseContent.creatureTypeList.beast"),
        "celestial": game.i18n.localize("MI.referenseContent.creatureTypeList.celestial"),
        "construct": game.i18n.localize("MI.referenseContent.creatureTypeList.construct"),
        "dragon": game.i18n.localize("MI.referenseContent.creatureTypeList.dragon"),
        "elemental": game.i18n.localize("MI.referenseContent.creatureTypeList.elemental"),
        "fey": game.i18n.localize("MI.referenseContent.creatureTypeList.fey"),
        "fiend": game.i18n.localize("MI.referenseContent.creatureTypeList.fiend"),
        "giant": game.i18n.localize("MI.referenseContent.creatureTypeList.giant"),
        "humanoid": game.i18n.localize("MI.referenseContent.creatureTypeList.humanoid"),
        "monstrosity": game.i18n.localize("MI.referenseContent.creatureTypeList.monstrosity"),
        "ooze": game.i18n.localize("MI.referenseContent.creatureTypeList.ooze"),
        "plant": game.i18n.localize("MI.referenseContent.creatureTypeList.plant"),
        "undead": game.i18n.localize("MI.referenseContent.creatureTypeList.undead")
    }
    let creatureTypeContainer = HtmlUtil.createElement("div", {elementClass: ["creatureTypeContainer"]});
    let labelCreatureType = HtmlUtil.createElement("label", {for: "creatureType", text: game.i18n.localize("MI.referenseContent.creatureType")});
    let creatureTypeSelect = HtmlUtil.createElement("select", {id: "creatureType", name: "creatureType"});
    let creatureTypeSorted = HtmlUtil.sortDict(creatureTypeOptions);
    for (let [key, value] of Object.entries(creatureTypeSorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        creatureTypeSelect.appendChild(option);
    }
    let buttonCreatureTypeContainer = HtmlUtil.createElement("div", {elementClass: ["buttonCreatureTypeContainer"]});
    let buttonCreatureType = HtmlUtil.createElement("button", {elementClass: ["buttonCreatureType", "button"], id: "buttonCreatureType", text: game.i18n.localize("MI.referenseContent.creatureTypeList.setCreatureType")});
    let creatureTypeDivPaked = HtmlUtil.toDivPack([labelCreatureType, creatureTypeSelect]);
    buttonCreatureTypeContainer.appendChild(buttonCreatureType);
    creatureTypeDivPaked.push(buttonCreatureTypeContainer);
    HtmlUtil.appendElements(creatureTypeContainer, creatureTypeDivPaked);
    divContentabiCreatureType.appendChild(creatureTypeContainer);
    return divContentabiCreatureType;
}

function getTypeDamageTab(){
    let divContentabiTypeDamage = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab5", data_group: "referense-tabs"});
    let divContentabiTypeDamageContainer = HtmlUtil.createElement("div", {elementClass: ["typeDamageContainer"]});
    let divContentabiTypeDamageAverageContainer = HtmlUtil.createElement("div", {elementClass: ["averageContainer"]});
    let labelDamageAverage = HtmlUtil.createElement("label", {for: "average", text: game.i18n.localize("MI.referenseContent.average")});
    let inputDamageAverage = HtmlUtil.createElement("input", {id: "average", type: "checkbox"});
    let inputDamageAverageNumber = HtmlUtil.createElement("input", {id: "numberAverage", type: "number"});
    let AverageDivPacked = HtmlUtil.toDivPack([labelDamageAverage, inputDamageAverage, inputDamageAverageNumber]);
    HtmlUtil.appendElements(divContentabiTypeDamageAverageContainer, AverageDivPacked);
    divContentabiTypeDamageContainer.appendChild(divContentabiTypeDamageAverageContainer)
    let typeDamageOptions = {
        "acid": game.i18n.localize("MI.referenseContent.typeDamageList.acid"),
        "bludgeoning": game.i18n.localize("MI.referenseContent.typeDamageList.bludgeoning"),
        "cold": game.i18n.localize("MI.referenseContent.typeDamageList.cold"),
        "fire": game.i18n.localize("MI.referenseContent.typeDamageList.fire"),
        "force": game.i18n.localize("MI.referenseContent.typeDamageList.force"),
        "lightning": game.i18n.localize("MI.referenseContent.typeDamageList.lightning"),
        "necrotic": game.i18n.localize("MI.referenseContent.typeDamageList.necrotic"),
        "piercing": game.i18n.localize("MI.referenseContent.typeDamageList.piercing"),
        "poison": game.i18n.localize("MI.referenseContent.typeDamageList.poison"),
        "psychic": game.i18n.localize("MI.referenseContent.typeDamageList.psychic"),
        "radiant": game.i18n.localize("MI.referenseContent.typeDamageList.radiant"),
        "slashing": game.i18n.localize("MI.referenseContent.typeDamageList.slashing"),
        "healing": game.i18n.localize("MI.referenseContent.typeDamageList.healing"),
        "temphp": game.i18n.localize("MI.referenseContent.typeDamageList.temphp")
    };
    let typeDamageOptionsSorted = HtmlUtil.sortDict(typeDamageOptions);
    let labelTypeDamage = HtmlUtil.createElement("label", {for: "typeDamage", text: game.i18n.localize("MI.referenseContent.typeDamage")});
    let selectTypeDamage = HtmlUtil.createElement("select", {id: "typeDamage", name: "typeDamage"});
    selectTypeDamage.appendChild(HtmlUtil.createElement("option", {value: "", text: game.i18n.localize("MI.referenseContent.typeDamageList.noType")}));
    for (let key in typeDamageOptionsSorted) {
        let option = HtmlUtil.createElement("option", {value: key, text: typeDamageOptionsSorted[key]});
        selectTypeDamage.appendChild(option);
    }
    let buttonTypeDamageContainer = HtmlUtil.createElement("div", {elementClass: ["buttonTypeDamageContainer"]});
    let buttonTypeDamage = HtmlUtil.createElement("button", {elementClass: ["buttonTypeDamage","button"], id: "buttonTypeDamage", text: game.i18n.localize("MI.referenseContent.typeDamageList.setDamageType")});
    let TypeDamageDivPacked = HtmlUtil.toDivPack([labelTypeDamage, selectTypeDamage]);
    buttonTypeDamageContainer.appendChild(buttonTypeDamage);
    TypeDamageDivPacked.push(buttonTypeDamageContainer);
    HtmlUtil.appendElements(divContentabiTypeDamageContainer, TypeDamageDivPacked)
    divContentabiTypeDamage.appendChild(divContentabiTypeDamageContainer);
    return divContentabiTypeDamage;
}

function getToolTab(){
    let divContentabitoolsList = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab6", data_group: "referense-tabs"});
    let divToolsContainer = HtmlUtil.createElement("div", {elementClass: ["ToolsContainer"]});
    let toolOptions = [
        "alchemist", "bagpipes", "brewer", "calligrapher",
        "card", "carpenter", "cartographer", "chess",
        "cobbler", "cook", "dice", "disg",
        "dulcimer", "flute", "forg", "glassblower",
        "herb", "horn", "leatherworker", "lute",
        "lyre", "mason", "navg", "painter",
        "panflute", "pois", "potter", "shawm",
        "smith", "thief", "tinker", "viol",
        "weaver", "woodcarver"
    ];
    let toolOptionsDict = {};
    for (let tool of toolOptions) {
        toolOptionsDict[tool] = game.i18n.localize(`MI.referenseContent.toolsList.${tool}`);
    };
    toolOptions = HtmlUtil.sortDict(toolOptionsDict);
    let abilityOptions = {
        "strength": game.i18n.localize("MI.referenseContent.abilityList.strength"),
        "dexterity": game.i18n.localize("MI.referenseContent.abilityList.dexterity"),
        "constitution": game.i18n.localize("MI.referenseContent.abilityList.constitution"),
        "intelligence": game.i18n.localize("MI.referenseContent.abilityList.intelligence"),
        "wisdom": game.i18n.localize("MI.referenseContent.abilityList.wisdom"),
        "charisma": game.i18n.localize("MI.referenseContent.abilityList.charisma")
    }
    let abilitySorted = HtmlUtil.sortDict(abilityOptions);
    let toolSelect = HtmlUtil.createElement("select", {id:"Tool", name:"Tool"});
    for (let [key, value] of Object.entries(toolOptions)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        toolSelect.appendChild(option);
    }
    let abilitySelect = HtmlUtil.createElement("select", {id:"abilityTool", name:"abilitTooly"});
    for (let [key, value] of Object.entries(abilitySorted)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        abilitySelect.appendChild(option);
    }
    let buttonToolContainer = HtmlUtil.createElement("div", {elementClass: ["buttonToolContainer"]});
    let buttonTool = HtmlUtil.createElement("button", {elementClass: ["buttonTool", "button"], id:"buttonTool", name: "buttonTool", text: game.i18n.localize("MI.referenseContent.toolsList.setTool")});
    buttonToolContainer.appendChild(buttonTool);
    HtmlUtil.appendElements(divToolsContainer, HtmlUtil.toDivPack([toolSelect, abilitySelect]));
    divToolsContainer.appendChild(buttonToolContainer);
    divContentabitoolsList.appendChild(divToolsContainer);
    return divContentabitoolsList;
}

function getAreaOfEffectTab(){
    let divContentAreaOfEffect = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab7", data_group: "referense-tabs"});
    let areaOfEffectContainer = HtmlUtil.createElement("div", {elementClass: ["areaOfEffectContainer"]});
    let labelAreaOfEffect = HtmlUtil.createElement("label", {for: "areaOfEffect", text: game.i18n.localize("MI.referenseContent.areaOfEffect")});
    let selectAreaOfEffect = HtmlUtil.createElement("select", {id: "areaOfEffect", name: "areaOfEffect"});
    let areaOfEffectOption ={
        "cone": game.i18n.localize("MI.referenseContent.areaOfEffectList.cone"),
        "cube": game.i18n.localize("MI.referenseContent.areaOfEffectList.cube"),
        "sphere": game.i18n.localize("MI.referenseContent.areaOfEffectList.sphere"),
        "square": game.i18n.localize("MI.referenseContent.areaOfEffectList.square"),
        "line": game.i18n.localize("MI.referenseContent.areaOfEffectList.line")
    };
    let sortedAreaOfEffectOption = HtmlUtil.sortDict(areaOfEffectOption);
    for (let [key, value] of Object.entries(sortedAreaOfEffectOption)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectAreaOfEffect.appendChild(option);
    }
    let buttonAreaOfEffectContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAreaOfEffectContainer"]});
    let buttonAreaOfEffect = HtmlUtil.createElement("button", {elementClass: ["buttonAreaOfEffect", "button"], id: "buttonAreaOfEffect", text: game.i18n.localize("MI.referenseContent.areaOfEffectList.setAreaOfEffect")});
    buttonAreaOfEffectContainer.appendChild(buttonAreaOfEffect);
    HtmlUtil.appendElements(areaOfEffectContainer, HtmlUtil.toDivPack([labelAreaOfEffect, selectAreaOfEffect]));
    areaOfEffectContainer.appendChild(buttonAreaOfEffectContainer);
    divContentAreaOfEffect.appendChild(areaOfEffectContainer);
    return divContentAreaOfEffect;
}

function getComponentTab(){
    let divContentComponent = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab8", data_group: "referense-tabs"});
    let componentContainer = HtmlUtil.createElement("div", {elementClass: ["componentContainer"]});
    let labelComponent = HtmlUtil.createElement("label", {for: "component", text: game.i18n.localize("MI.referenseContent.component")});
    let selectComponent = HtmlUtil.createElement("select", {id: "component", name: "component"});
    let componentOption = {
        "concentration": game.i18n.localize("MI.referenseContent.componentList.concentration"),
        "material": game.i18n.localize("MI.referenseContent.componentList.material"),
        "ritual": game.i18n.localize("MI.referenseContent.componentList.ritual"),
        "somatic": game.i18n.localize("MI.referenseContent.componentList.somatic"),
        "verbal": game.i18n.localize("MI.referenseContent.componentList.verbal")
    }
    let sortedComponentOption = HtmlUtil.sortDict(componentOption);
    for (let [key, value] of Object.entries(sortedComponentOption)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        selectComponent.appendChild(option);
    }
    let buttonComponentContainer = HtmlUtil.createElement("div", {elementClass: ["buttonComponentContainer"]});
    let buttonComponent = HtmlUtil.createElement("button", {elementClass: ["buttonComponent", "button"], id: "buttonComponent", text: game.i18n.localize("MI.referenseContent.componentList.setComponent")});
    buttonComponentContainer.appendChild(buttonComponent);
    let divComponentPacked = HtmlUtil.toDivPack([labelComponent, selectComponent]);
    divComponentPacked.push(buttonComponentContainer);
    HtmlUtil.appendElements(componentContainer, divComponentPacked);
    divContentComponent.appendChild(componentContainer);
    return divContentComponent;
}

function getSpellSchoolTab(){
    let divContentspellSchool = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab9", data_group: "referense-tabs"});
    let spellSchoolContainer = HtmlUtil.createElement("div", {elementClass: ["spellSchoolContainer"]});
    let labelSpellSchool = HtmlUtil.createElement("label", {for: "spellSchool", text: game.i18n.localize("MI.referenseContent.spellSchool")});
    let spellSchoolOption = {
        "abjuration": game.i18n.localize("MI.referenseContent.spellSchoolList.abjuration"),
        "conjuration": game.i18n.localize("MI.referenseContent.spellSchoolList.conjuration"),
        "divination": game.i18n.localize("MI.referenseContent.spellSchoolList.divination"),
        "enchantment": game.i18n.localize("MI.referenseContent.spellSchoolList.enchantment"),
        "evocation": game.i18n.localize("MI.referenseContent.spellSchoolList.evocation"),
        "illusion": game.i18n.localize("MI.referenseContent.spellSchoolList.illusion"),
        "necromancy": game.i18n.localize("MI.referenseContent.spellSchoolList.necromancy"),
        "transmutation": game.i18n.localize("MI.referenseContent.spellSchoolList.transmutation")
    }
    let selectSpellSchool = HtmlUtil.createElement("select", {id: "spellSchool", name: "spellSchool"});
    let sortedSpellSchoolOption = HtmlUtil.sortDict(spellSchoolOption);
    for(let key in sortedSpellSchoolOption){
        let option = HtmlUtil.createElement("option", {value: key, text: sortedSpellSchoolOption[key]});
        selectSpellSchool.appendChild(option);
    }
    let buttonSpellSchoolContainer = HtmlUtil.createElement("div", {elementClass: ["buttonSpellSchoolContainer"]});
    let buttonSpellSchool = HtmlUtil.createElement("button", {elementClass: ["buttonSpellSchool", "button"],id: "buttonSpellSchool", text: game.i18n.localize("MI.referenseContent.spellSchoolList.setSpellSchool"), elementClass: ["buttonSpellSchool"]});
    buttonSpellSchoolContainer.appendChild(buttonSpellSchool);
    HtmlUtil.appendElements(spellSchoolContainer, HtmlUtil.toDivPack([labelSpellSchool, selectSpellSchool]))
    spellSchoolContainer.appendChild(buttonSpellSchoolContainer);
    divContentspellSchool.appendChild(spellSchoolContainer);
    return divContentspellSchool;
}

function getRulesTab(){
    let divContentabirules = HtmlUtil.createElement("div", {elementClass: ["tab"], data_tab: "tab10", data_group: "referense-tabs"});
    let divrulesContainer = HtmlUtil.createElement("div", {elementClass: ["rulesContainer"]});
    let labelrules = HtmlUtil.createElement("label",{for: "rules", text: game.i18n.localize("MI.referenseContent.rules")});
    let rulesOptions = [
        "inspiration", "carryingcapacity", "push", "lift", "drag", "encumbrance",
        "hiding", "passiveperception", "time", "speed", "travelpace", "forcedmarch",
        "difficultterrainpace", "climbing", "swimming", "longjump", "highjump", "falling",
        "suffocating", "vision", "light", "lightlyobscured", "heavilyobscured", "brightlight",
        "dimlight", "darkness", "blindsight", "darkvision", "tremorsense", "truesight",
        "food", "water", "resting", "shortrest", "longrest", "surprise",
        "initiative", "bonusaction", "reaction", "difficultterrain", "beingprone", "droppingprone",
        "standingup", "crawling", "movingaroundothercreatures", "flying", "size", "space",
        "squeezing", "attack", "castaspell", "dash", "disengage", "dodge",
        "help", "hide", "ready", "search", "useanobject", "attackrolls",
        "unseenattackers", "unseentargets", "rangedattacks", "range", "rangedattacksinclosecombat", "meleeattacks",
        "reach", "unarmedstrike", "opportunityattacks", "twoweaponfighting", "grappling", "escapingagrapple",
        "movingagrappledcreature", "shoving", "cover", "halfcover", "threequarterscover", "totalcover",
        "hitpoints", "damagerolls", "criticalhits", "damagetypes", "damageresistance", "damagevulnerability",
        "healing", "instantdeath", "deathsavingthrows", "deathsaves", "stabilizing", "knockingacreatureout",
        "temporaryhitpoints", "temphp", "mounting", "dismounting", "controllingamount", "underwatercombat",
        "spelllevel", "knownspells", "preparedspells", "spellslots", "castingatahigherlevel", "upcasting",
        "castinginarmor", "cantrips", "rituals", "castingtime", "bonusactioncasting", "reactioncasting",
        "longercastingtimes", "spellrange", "components", "verbal", "spellduration", "instantaneous",
        "concentrating", "spelltargets", "areaofeffect", "pointoforigin", "spellsavingthrows", "spellattackrolls",
        "combiningmagicaleffects", "schoolsofmagic", "detectingtraps", "disablingtraps", "curingmadness", "damagethreshold",
        "poisontypes", "contactpoison", "ingestedpoison", "inhaledpoison", "injurypoison", "attunement",
        "wearingitems", "wieldingitems", "multipleitemsofthesamekind", "paireditems", "commandword", "consumables",
        "itemspells", "charges", "spellscroll", "creaturetags", "telepathy", "legendaryactions",
        "lairactions", "regionaleffects", "disease"
    ];
    let rulesOptionsDict = {};
    for (let rule of rulesOptions) {
        rulesOptionsDict[rule] = game.i18n.localize(`MI.referenseContent.rulesList.${rule}`);
    };
    rulesOptions = HtmlUtil.sortDict(rulesOptionsDict);

    let rulesSelect = HtmlUtil.createElement("select", {id:"rulesSelect", name:"rulesSelect"});
    for (let [key, value] of Object.entries(rulesOptions)){
        let option = HtmlUtil.createElement("option", {value: key, text: value});
        rulesSelect.appendChild(option);
    }

    let buttonRulesContainer = HtmlUtil.createElement("div", {elementClass: ["buttonRulesContainer"]});
    let buttonRules = HtmlUtil.createElement("button", {elementClass: ["buttonRules", "button"], id:"buttonRules", text: game.i18n.localize("MI.referenseContent.rulesList.setRules")});
    buttonRulesContainer.appendChild(buttonRules);
    HtmlUtil.appendElements(divrulesContainer, HtmlUtil.toDivPack([labelrules, rulesSelect]));
    divrulesContainer.appendChild(buttonRulesContainer);
    divContentabirules.appendChild(divrulesContainer);
    return divContentabirules;
}

function createAwardsTab(){
    let awardsContainer = HtmlUtil.createElement("div", {elementClass: ["awardsContainer"]});
    let awardsList = [
        [
            {"label": {for: "pp", text: game.i18n.localize("MI.awordsContent.pp")}},
            {"input": {type: "number", id: "pp", name: "pp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/platinum.webp", name: "ppImg"}},
        ],
        [
            {"label": {for: "gp", text: game.i18n.localize("MI.awordsContent.gp")}},
            {"input": {type: "number", id: "gp", name: "gp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/gold.webp", name: "gpImg"}},
        ],
        [
            {"label": {for: "ep", text: game.i18n.localize("MI.awordsContent.ep")}},
            {"input": {type: "number", id: "ep", name: "ep", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/electrum.webp", name: "epImg"}},
        ],
        [
            {"label": {for: "sp", text: game.i18n.localize("MI.awordsContent.sp")}},
            {"input": {type: "number", id: "sp", name: "sp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/silver.webp", name: "spImg"}},
        ],
        [
            {"label": {for: "cp", text: game.i18n.localize("MI.awordsContent.cp")}},
            {"input": {type: "number", id: "cp", name: "cp", value: ""}},
            {"img": {src: "systems/dnd5e/icons/currency/copper.webp", name: "cpImg"}},
        ],
        [
            {"label": {for: "xp", text: game.i18n.localize("MI.awordsContent.xp")}},
            {"input": {type: "number", id: "xp", name: "xp", value: ""}},
            {"img": {src: "systems/dnd5e/ui/inspiration.webp", name: "xpImg"}},
        ],
        [
            {"label": {for: "party", text: game.i18n.localize("MI.awordsContent.party")}},
            {"input": {type: "checkbox", id: "party", name: "party", value: ""}},
            {"i": {elementClass: ["fa-solid", "fa-people-group"], name: "partyImg"}},
        ],
        [
            {"label": {for: "each", text: game.i18n.localize("MI.awordsContent.each")}},
            {"input": {type: "checkbox", id: "each", name: "each", value: ""}},
            {"i": {elementClass: ["fa-solid", "fa-fw", "fa-user"], name: "eachImg"}},
        ]
    ];
    for (let divs of awardsList){
        let divGroup = HtmlUtil.createElement("div", {elementClass: ["form-group"]});
        for (let div of divs){
            let elements = [];
            for (let [key, value] of Object.entries(div)){
                let element = HtmlUtil.createElement(key, value);
                elements.push(element);
            }
            HtmlUtil.appendElements(divGroup, HtmlUtil.toDivPack(elements));
        }
        awardsContainer.appendChild(divGroup);
    }
    // <div class="buttonClearContainer"><button id="buttonClear" class="buttonClear button">${game.i18n.localize("MI.awordsContent.clear")}</button></div>
    // <div class="buttonAwordsContainer"><button id="buttonAwords" class="buttonAwords button">${game.i18n.localize("MI.awordsContent.setAward")}</button></div>
    let buttonClearContainer = HtmlUtil.createElement("div", {elementClass: ["buttonClearContainer"]});
    let buttonClear = HtmlUtil.createElement("button", {elementClass: ["buttonClear", "button"], id:"buttonClear", text: game.i18n.localize("MI.awordsContent.clear")});
    let buttonAwordsContainer = HtmlUtil.createElement("div", {elementClass: ["buttonAwordsContainer"]});
    let buttonAwords = HtmlUtil.createElement("button", {elementClass: ["buttonAwords", "button"], id:"buttonAwords", text: game.i18n.localize("MI.awordsContent.setAward")});
    buttonClearContainer.appendChild(buttonClear);
    buttonAwordsContainer.appendChild(buttonAwords);
    HtmlUtil.appendElements(awardsContainer, [buttonClearContainer, buttonAwordsContainer]);

    return awardsContainer.outerHTML;
}

export class BookOfMagicInk extends FormApplication {

    
    awardsContent = `
        <div class="awardsContainer">
            <div class="form-group">
                <div><label for="pp">${game.i18n.localize("MI.awordsContent.pp")}:</label></div>
                <div><input type="number" id="pp" name="pp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/platinum.webp" name="ppImg" ></div>
            </div>
            <div class="form-group">
                <div><label for="gp">${game.i18n.localize("MI.awordsContent.gp")}:</label></div>
                <div><input type="number" id="gp" name="gp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/gold.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="ep">${game.i18n.localize("MI.awordsContent.ep")}:</label></div>
                <div><input type="number" id="ep" name="ep" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/electrum.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="sp">${game.i18n.localize("MI.awordsContent.sp")}:</label></div>
                <div><input type="number" id="sp" name="sp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/silver.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="cp">${game.i18n.localize("MI.awordsContent.cp")}:</label></div>
                <div><input type="number" id="cp" name="cp" value=""></div>
                <div><img src="systems/dnd5e/icons/currency/copper.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="xp">${game.i18n.localize("MI.awordsContent.xp")}:</label></div>
                <div><input type="number" id="xp" name="xp" value=""></div>
                <div><img src="systems/dnd5e/ui/inspiration.webp" name="ppImg"></div>
            </div>
            <div class="form-group">
                <div><label for="party">${game.i18n.localize("MI.awordsContent.party")}:</label></div>
                <div><input type="checkbox" id="party" name="party" value=""></div>
                <div><i class="fa-solid fa-people-group"></i></div>
            </div>
            <div class="form-group">
                <div><label for="each">${game.i18n.localize("MI.awordsContent.each")}:</label></div>
                <div><input type="checkbox" id="each" name="each" value=""></div>
                <div><i class="fa-solid fa-fw fa-user"></i></div>
            </div>
            <div class="buttonClearContainer"><button id="buttonClear" class="buttonClear button">${game.i18n.localize("MI.awordsContent.clear")}</button></div>
            <div class="buttonAwordsContainer"><button id="buttonAwords" class="buttonAwords button">${game.i18n.localize("MI.awordsContent.setAward")}</button></div>
        </div>
            `
    colorContent = `
            <div class="ColorContent">
                <div class="ColorContentRow">
                    <div><label for="colour">${game.i18n.localize("MI.colorContent.color")}:</label></div>
                    <div><input type="color" id="colour" name="color" value="#ffffff"></div>
                </div>
                <div><input type="text" id="colorHex" name="colorHex" value="#ffffff"></div>
                <div class="ColorContentRow">
                    <div><input id="nameColor" type="text"></div>
                    <div data="button"><button id="buttonColorAdd" class="buttonColorAdd button">${game.i18n.localize("MI.colorContent.save")}</button></div>
                </div>
                <div class="ColorContentRow">
                    <div data="button"><button id="buttonColor" class="buttonColor button">${game.i18n.localize("MI.colorContent.setColourText")}</button></div>
                    <div data="button"><button id="buttonColorBackground" class="buttonColorBackground button">${game.i18n.localize("MI.colorContent.setColourBorder")}</button></div>
                </div>
                <div class="ColorContentRow">
                    <div>
                        <select id="userPalette" name="userPalette">
                        </select>
                    </div>
                    <div data="button"><button id="buttonDeleteColor" class="buttonDeleteColor button">${game.i18n.localize("MI.colorContent.deleteColor")}</button></div>
                </div>
            </div>
    `

    static get defaultOptions() {
        return foundry.utils.mergeObject(super.defaultOptions, {
            object: {},
            template: "./modules/arcane-ink/templates/book.hbs",
            popOut: true,
            resizable: true,
            title: game.i18n.localize("MI.name"),
            tabs: [
                {navSelector: ".tabs", contentSelector: ".content", initial: "tab1"}, 
                {navSelector: ".referenseTabs", contentSelector: ".contentRef", initial: "tab1"}
            ]
        });
    }

    getSelectedText(){
        let selectedText = document.getSelection().getRangeAt(0).cloneContents();
        const serializer = new XMLSerializer();
        selectedText = serializer.serializeToString(selectedText);
        selectedText = selectedText.replaceAll('xmlns="http://www.w3.org/1999/xhtml"', "");
        return selectedText
    }

    async pathPicker(inputForm, img, butImg){
        let path = new FilePicker();
        dataBook.filePath = inputForm;
        dataBook.fileImg = img;
        dataBook.buttonImg = butImg;
        path.callback = this.make_path;
        path.render();
    }

    async make_path(args){
        game.user.setFlag(moduleName, "picturePath", args);
        dataBook.filePath[0].value = args;
        dataBook.fileImg[0].src = args;
        dataBook.buttonImg[0].src = args;
    }

    getData(app, html) {
        const data = super.getData();

        data.footer = `${game.i18n.localize("MI.footer")}<a href="${game.i18n.localize("MI.boostSite")}">${game.i18n.localize("MI.boostSite")}</a>`;

        data.tabs = [{ 
            id: "tab1",
            label: "tab1",
            title: game.i18n.localize("MI.mainTabs.pictureAndDesign"),
            content: createPicturesContent()
        },
        { 
            id: "tab2",
            label: "tab2",
            title: game.i18n.localize("MI.mainTabs.reference"),
            content: createReferenseContentTabs()
        },
        { 
            id: "tab3",
            label: "tab3",
            title: game.i18n.localize("MI.mainTabs.award"),
            content: createAwardsTab()
        },
        { 
            id: "tab4",
            label: "tab4",
            title: game.i18n.localize("MI.mainTabs.color"),
            content: this.colorContent
        },
    ];
        return data;
    }

    async formLoading(html){
        dataBook.colorHex = html.find('[id="colorHex"]');
        dataBook.colorViget = html.find('[id="colour"]');
        dataBook.select = html.find('[id="userPalette"]');
        dataBook.filePath = html.find('[name="picturesInput"]');
        dataBook.fileImg = html.find('[name="refImg"]');
        dataBook.buttonImg = html.find('[id="butImg"]');
        dataBook.filePath[0].value = (game.user.getFlag(moduleName, "picturePath") !== undefined) ? game.user.getFlag(moduleName, "picturePath") : "icons/vtt-512.png";
        dataBook.fileImg[0].src = dataBook.filePath[0].value;
        dataBook.buttonImg[0].src = dataBook.filePath[0].value;
        dataBook.userColors = game.user.getFlag(moduleName, "userColors") ? game.user.getFlag(moduleName, "userColors"): {};
        if (game.user.getFlag(moduleName, "rounded")){
            let round = html.find('[name="onCircle"]');
            await round.prop( "checked", true);
            await round.trigger('change');
        }
        dataBook.select.find('option').remove();
        for (const [_color, _name] of Object.entries(dataBook.userColors)) {
            await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
        }
        await dataBook.select.trigger('change');
    }
    activateListeners(html) {
        this.formLoading(html);

        html.on('click', '#refImg', () => {
            this.pathPicker(html.find('[name="picturesInput"]'), html.find('[name="refImg"]'), html.find('[id="butImg"]'));
        })

        html.on('change', '#picturesInput', () => {
            this.make_path(html.find('[name="picturesInput"]')[0].value);
        })  

        html.on('click', '#addPictures', () => {
            let scale = html.find('[name="scale"]')[0].value;
            let direction = '';
            let circle = '';
            if (html.find('[name="leftCheck"]')[0].checked) {
                direction = 'left';
            }
            if (html.find('[name="onCircle"]')[0].checked) {
                circle = 'class="round"';
            }
            if (html.find('[name="rightCheck"]')[0].checked) {
                direction = 'right';
            }
            let width = html.find('[name="widthPic"]')[0].value;
            let height = html.find('[name="heightPic"]')[0].value;
            let icon = html.find('[name="picturesInput"]')[0].value;
            let selectedText = document.getSelection().toString();
            let newContent = `<figure class="${direction} ${scale}"><img src=${icon} ${circle} width="${width}" height="${height}"><figcaption><p>${selectedText}</p></figcaption></figure>`;
            document.execCommand('insertHTML', false, newContent);
          })

        html.on('click', '#buttonAbility', () => {
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let check = "/check";
            let passive = '';
            let result;
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive ';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let ability = html.find('[name="ability"]')[0].value;
            if (html.find('[name="abilityCheck"]')[0].checked) {
                check = '/save';
            }
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0];
                }
            }
            let newContent = `[[${check} ${passive}${ability} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[${check} ${passive}${ability} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
          })

        html.on('click', '#buttonSkill', () => {
            let pattern = new RegExp('[\\d]{1,2}[d,D,к,К][\\d]{1,3}');
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let passive = '';
            let result;
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive ';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let skill = html.find('[name="skill"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0];
                }
            }
            let newContent = `[[/skill ${passive}${skill} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[/skill ${passive}${skill} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonTypeDamage', () => {  //////22222222222222222222222222
            let pattern = new RegExp('[\\d]{1,2}[d,D,к,К,k,K,д,Д][\\d]{1,3}');
            let d = new RegExp('[D,к,К,k,K,д,Д]');
            let selectedText = document.getSelection().toString();
            let average = '';
            let damage = '/damage'
            let result;
            if (selectedText){
                result = selectedText.match(pattern);
                if (result){
                    result = result[0].replace(d, 'd')
                }
                else{
                    let num = new RegExp('\\d{1,3}');
                    result = selectedText.match(num)[0];
                }
            }
            if (html.find('[id="average"]')[0].checked) {
                average = html.find('[id="numberAverage"]')[0].value | 'true';
                average = `average=${average}`;
            }
            let damageFormula = html.find('[id="damageFormula"]')[0].value;
            damageFormula = damageFormula.replace(d, 'd')
            let typeDamage = html.find('[name="typeDamage"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                if (result){
                    damageFormula = result
                }
            }
            let newContent = `[[${damage} ${damageFormula} ${typeDamage} ${average}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[${damage} ${damageFormula} ${typeDamage} ${average}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonTool', () => {
            let num = new RegExp('\\d{1,3}');
            let selectedText = document.getSelection().toString();
            let passive = '';
            let average = '';
            let result;
            if (html.find('[id="average"]')[0].checked) {
                average = 'average'
            }
            if (html.find('[id="skillPassiveCheck"]')[0].checked){
                passive = 'passive';
            }
            let modify = html.find('[id="numberForMod"]')[0].value | 0;
            let tool = html.find('[name="Tool"]')[0].value;
            let ability = html.find('[name="abilitTooly"]')[0].value;
            if (html.find('[id="numberCheck"]')[0].checked){
                result = selectedText.match(num);
                if (result){
                    modify = result[0]
                }
            }
            let newContent = `[[/tool ${passive} ${tool} ${ability} ${modify}]]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `[[/tool ${passive} ${tool} ${ability} ${modify}]]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonCondition', () => {
            let selectedText = document.getSelection().toString();
            let condition = html.find('[name="condition"]')[0].value;
            let newContent = `&Reference[${condition}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${condition}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonCreatureType', () => {
            let selectedText = document.getSelection().toString();
            let creatureType = html.find('[name="creatureType"]')[0].value;
            let newContent = `&Reference[${creatureType}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${creatureType}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonAreaOfEffect', () => {
            let selectedText = document.getSelection().toString();
            let areaOfEffect = html.find('[name="areaOfEffect"]')[0].value;
            let newContent = `&Reference[${areaOfEffect}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${areaOfEffect}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonComponent', () => {
            let selectedText = document.getSelection().toString();
            let component = html.find('[name="component"]')[0].value;
            let newContent = `&Reference[${component}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${component}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonSpellSchool', () => {
            let selectedText = document.getSelection().toString();
            let spellSchool = html.find('[name="spellSchool"]')[0].value;
            let newContent = `&Reference[${spellSchool}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${spellSchool}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonRules', () => {
            let selectedText = document.getSelection().toString();
            let rulles = html.find('[name="rulesSelect"]')[0].value;
            let newContent = `&Reference[${rulles}]{${selectedText}}`;
            if (html.find('[id="NullCheck"]')[0].checked | !selectedText){
                newContent = `&Reference[${rulles}]`;
            }
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonAwords', () => {
            let pp = html.find('[id="pp"]')[0].value;
            let gp = html.find('[id="gp"]')[0].value;
            let ep = html.find('[id="ep"]')[0].value;
            let sp = html.find('[id="sp"]')[0].value;
            let cp = html.find('[id="cp"]')[0].value;
            let xp = html.find('[id="xp"]')[0].value;
            let partyCheck = html.find('[id="party"]');
            let eachCheck = html.find('[id="each"]');
            let party = '';
            let each = '';
            console.log(eachCheck[0].checked)
            if (partyCheck[0].checked) {
                party = "party ";
            }
            if (eachCheck[0].checked) {
                each = "each ";
            }
            if (pp){pp = `${pp}pp `;} else {pp = ``;}
            if (gp){gp = `${gp}gp `;} else {gp = ``;}
            if (ep){ep = `${ep}ep `;} else {ep = ``;}
            if (sp){sp = `${sp}sp `;} else {sp = ``;}
            if (cp){cp = `${cp}cp `;} else {cp = ``;}
            if (xp){xp = `${xp}xp `;} else {xp = ``;}
            let result = `${party}${pp}${gp}${ep}${sp}${cp}${xp}${each}`
            result = result.trim();
            if (result !== '' && result !== 'party' && result !== 'each' && result !== 'party each' ){
                let newContent = `[[/award ${result}]]`;
                document.execCommand('insertHTML', false, newContent);
            }
        })

        html.on('click', '#buttonClear', () => {
            html.find('[id="pp"]')[0].value = '';
            html.find('[id="gp"]')[0].value = '';
            html.find('[id="ep"]')[0].value = '';
            html.find('[id="sp"]')[0].value = '';
            html.find('[id="cp"]')[0].value = '';
            html.find('[id="xp"]')[0].value = '';
            html.find('[id="party"]').prop( "checked", false );
            html.find('[id="each"]').prop( "checked", false );
        })

        html.on('click', '#narrative', () => {
            let selectedText = this.getSelectedText();
            let newContent = `
            <section class="fvtt-relative">
                <section class="fvtt narrative">
                    <p>${selectedText}</p>
                </section>
            </section>
            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#advice', () => {
            let selectedText = this.getSelectedText();
            let circle = '';
            if (html.find('[name="onCircle"]')[0].checked) {
                circle = 'class="round"';
            }
            let icon = html.find('[name="picturesInput"]')[0].value;
            let newContent = `
            <div>
            <section class="fvtt advice">
                <figure class="icon">
                    <img src=${icon} ${circle}>
                </figure>
                <article>
                    ${selectedText}
                </article>
            </section>
            </div>
            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#notable', () => {
            let selectedText = this.getSelectedText();
            let newContent = `
            <aside class="notable">
                <p>${selectedText}</p>
            </aside>

            `;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonColorAdd', async () => {
            await game.user.setFlag(moduleName, "userColors", null);
            let color = dataBook.colorViget[0].value;
            let name = html.find('[id="nameColor"]')[0].value;
            dataBook.userColors[color] = name;
            await dataBook.select.find('option').remove();
            await game.user.setFlag(moduleName, "userColors", dataBook.userColors);
            for (const [_color, _name] of Object.entries(dataBook.userColors)) {
                await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
            }
            dataBook.select.val(color).selected = true;
            await dataBook.select.trigger('change');
        })

        html.on('click', '#buttonColor', async () => {
            let color = dataBook.colorViget[0].value;
            let selectedText = document.getSelection().toString();
            let newContent = `<span style="color:${color};">${selectedText}</span>`;
            document.execCommand('insertHTML', false, newContent);
        })

        html.on('click', '#buttonColorBackground', async () => {
            let color = dataBook.colorViget[0].value;
            let selectedText = this.getSelectedText();
            let newContent = `<div style="padding:0px 5px;background-color:${color};border:1px outset black;box-shadow:2px 2px 2px;border-radius:5px">${selectedText}</div>`;
            document.execCommand('insertHTML', false, newContent);
         
        })

        html.on('click', '#buttonDeleteColor', async () => {
            await game.user.setFlag(moduleName, "userColors", null);
            await delete dataBook.userColors[dataBook.select[0].value];
            await dataBook.select.find('option').remove();
            await game.user.setFlag(moduleName, "userColors", dataBook.userColors);
            for (const [_color, _name] of Object.entries(dataBook.userColors)) {
                await dataBook.select.append(`<option style="background-color: ${_color};" value=${_color} >${_name}</option>`);
            }
            dataBook.select.trigger('change');
        })

        html.find('.itemRef').click((e) => {
            const clickedTabId = e.currentTarget.dataset.tab;
            if (clickedTabId == "tab1" | clickedTabId == "tab2" | clickedTabId == "tab6"){
                html.find('.numberCheck').show();
                html.find('.skillPassiveCheck').show();
                html.find('.numberForMod').show();
            }
            else{
                html.find('.numberCheck').hide();
                html.find('.skillPassiveCheck').hide();
                html.find('.numberForMod').hide();
            }
            if (clickedTabId == "tab5"){
                html.find('.damageFormula').show();
                html.find('.numberCheck').show();
            }
            else{
                html.find('.damageFormula').hide();
            }
        });
        
        html.on('change', '#colour', (event) => {
            dataBook.colorHex[0].value = dataBook.colorViget[0].value;
        })
        
        html.on('change', '#colorHex', (event) => {
            let color = dataBook.colorHex[0].value
            if (color.startsWith('#')){
                dataBook.colorViget[0].value = dataBook.colorHex[0].value;
        }
        })

        html.on('change', '#numberCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[id="numberForMod"]').prop( "disabled", true);
                html.find('[id="damageFormula"]').prop( "disabled", true);
              } else {
                html.find('[id="numberForMod"]').prop( "disabled", false);
                html.find('[id="damageFormula"]').prop( "disabled", false);
              }
        })

        html.on('change', '#onCircle', (event) => {
            if (event.currentTarget.checked) {
                dataBook.fileImg.addClass(['round']);
                dataBook.buttonImg.addClass(['round']);
                game.user.setFlag(moduleName, "rounded", true)
              } else {
                dataBook.fileImg.removeClass(['round']);
                dataBook.buttonImg.removeClass(['round']);
                game.user.setFlag(moduleName, "rounded", false)
              }
        })

        html.on('change', '#userPalette', (event) => {
            dataBook.colorViget[0].value = dataBook.select[0].value;
            dataBook.select.css("background", dataBook.select[0].value);
        })

        html.on('change', '#leftCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[name="rightCheck"]').prop( "checked", false );
              }
        })

        html.on('change', '#rightCheck', (event) => {
            if (event.currentTarget.checked) {
                html.find('[name="leftCheck"]').prop( "checked", false );
            }
        })
    }
    //class="round"

}

export class HtmlUtil {
    static book;
    static appendHeaderButton(html, title, fn) {
        let openBtn = $(`<a class="potion" title="${title}"><i class="fas fa-flask-round-potion"></i>${title}</a>`);
        openBtn.click(fn);
        html.closest('.app').find('.potion').remove();
        let titleElement = html.closest('.app').find('.window-title');
        openBtn.insertAfter(titleElement);
    }

    static toDivPack(listElements){
        let result = [];
        for (const _element of listElements){
            let div = document.createElement('div');
            div.appendChild(_element);
            result.push(div);
        }
        return result;
    }

    static createElement(element, args) {
        //args = {elementClass = [], id, name, for, data, data_tab, data-group, type, value, src, text}
        const _element = document.createElement(element);
        if (args?.elementClass){
            for (const _class in args.elementClass){
                _element.classList.add(args.elementClass[_class]);
            }
        }
        if (args?.id){
            _element.setAttribute("id", args.id);
        }
        if (args?.name){
            _element.setAttribute("name", args.name);
        }
        if (args?.for){
            _element.setAttribute("for", args.for);
        }
        if (args?.data){
            _element.setAttribute("data", args.data);
        }
        if (args?.data_tab){
            _element.setAttribute("data-tab", args.data_tab);
        }
        if (args?.data_group){
            _element.setAttribute("data-group", args.data_group);
        }
        if (args?.type){
            _element.setAttribute("type", args.type);
        }
        if (args?.value){
            _element.setAttribute("value", args.value);
        }
        if (args?.src){
            _element.setAttribute("src", args.src);
        }
        if (args?.text){
            _element.innerHTML = args.text;
        }
        return _element;
    }
    static appendElements(_element, _elements){
        // element, elements = []
        for (const _elementIn of _elements){
            _element.appendChild(_elementIn);
        }
    }
    static sortDict(_dict){
        return Object.fromEntries(
            Object.entries(_dict).sort(([, a], [, b]) => a.localeCompare(b))
          );
    }
}